package eu.univento.teamvento.commands;

import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Rank;
import eu.univento.teamvento.TeamVento;
import org.bukkit.Bukkit;
import org.bukkit.WorldCreator;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.io.IOException;
import java.util.List;

/**
 * @author joethei
 * @version 0.1
 */
public class WorldImport extends AutoCommand<TeamVento>{

    public WorldImport(TeamVento plugin, String command, String description, String... aliases) {
        super(plugin, command, description, aliases);
    }

    @Override
    public boolean execute(CommandSender sender, String label, String[] args) {
        if(sender instanceof Player) {
            CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
            if (p.isAllowed(Rank.SrBuilder)) {
                if(args.length == 1) {
                    if(Bukkit.getWorld(args[0]) == null) {
                        Bukkit.createWorld(new WorldCreator(args[0]));
                        TeamVento.getCfg().set(args[0], args[1]);
                        try {
                            TeamVento.getCfg().save(TeamVento.getConfigFile());
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        p.sendMessage(p.getMessages().PREFIX() + "§ayour world has been imported");
                    }else{
                        p.sendMessage(p.getMessages().PREFIX() + "§cthe chosen world already exists");
                    }
                }else{
                    p.sendMessage(p.getMessages().PREFIX() + "§cplease use /worldimport <name>");
                }
            }else{
                p.sendMessage(p.getMessages().NO_PERMS());
            }
        }else{
            sender.sendMessage(Messages.Console.NOT_A_PLAYER);
        }
        return true;
    }

    @Override
    public List<String> tabComplete(CommandSender sender, String label, String[] args) {
        return null;
    }
}