package eu.univento.teamvento.commands;

import eu.univento.core.api.AutoCommand;
import eu.univento.core.api.languages.Messages;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.core.api.player.Rank;
import eu.univento.teamvento.TeamVento;
import org.bukkit.Bukkit;
import org.bukkit.World;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author joethei
 * @version 0.1
 */
public class WorldTP extends AutoCommand<TeamVento>{

    public WorldTP(TeamVento plugin, String command, String description, String... aliases) {
        super(plugin, command, description, aliases);
    }

    @Override
    public boolean execute(CommandSender sender, String label, String[] args) {
        if(sender instanceof Player) {
            CustomPlayer p = CustomPlayer.getPlayer(sender.getName());
            if(p.isAllowed(Rank.Supporter)) {
                if(args.length == 1) {
                    if(Bukkit.getWorld(args[0]) != null) {
                        p.teleport(Bukkit.getWorld(args[0]).getSpawnLocation());
                        p.sendMessage(p.getMessages().PREFIX() + "§aDu hast die Welt gewechselt");
                    }else{
                        p.sendMessage(p.getMessages().PREFIX() + "§cDie Welt " + args[0] + " exsistiert nicht");
                    }
                }else {
                    p.sendMessage(p.getMessages().PREFIX() + "§cDie Anzahl der Argumente stimmt nicht");
                }
            }else{
                p.sendMessage(p.getMessages().NO_PERMS());
            }
        }else{
            sender.sendMessage(Messages.Console.NOT_A_PLAYER);
        }
        return true;
    }

    @Override
    public List<String> tabComplete(CommandSender sender, String label, String[] args) {
        return Bukkit.getWorlds().stream().map(World::getName).collect(Collectors.toCollection(ArrayList::new));
    }
}