package eu.univento.teamvento.listener;

import eu.univento.core.api.Config;
import eu.univento.core.api.Hologram;
import eu.univento.core.api.player.CustomPlayer;
import eu.univento.teamvento.TeamVento;
import eu.univento.teamvento.utils.Plot;
import eu.univento.teamvento.utils.PlotManager;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.block.Sign;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;

public class SignInteract implements Listener {

    @EventHandler
    public void onInteract(PlayerInteractEvent e) {
        CustomPlayer p = CustomPlayer.getPlayer(e.getPlayer());
        if (e.getAction() == Action.RIGHT_CLICK_BLOCK) {
            if(e.getClickedBlock().getType() == Material.ENCHANTMENT_TABLE && e.getClickedBlock().getLocation().add(0.0D, -1.0D, 0.0D).getBlock().getType() == Material.COMMAND) {
                e.setCancelled(true);
                if (PlotManager.hasPlot(p)) {
                    Location loc = PlotManager.getPlotByPlayer(p).getSpawn();
                    p.teleport(new Location(Bukkit.getWorld("plots"), loc.getX(), loc.getY(), loc.getZ(), 89.0F, 6.0F));
                } else {
                    p.sendTitle("§eBitte warten", "§aDein Grundstück wird generiert");
                    JoinQuit.holograms.get(p).hidePlayer(p);
                    Hologram holo = new Hologram(new String[]{"§eZu deinem Plot teleportieren", "|", "|", "▼"}, Config.readLocation("Build.Locs.Holo"));
                    holo.showPlayer(p);
                    Plot plot = PlotManager.createPlot(p);
                    PlotManager.createPlot(plot);
                    PlotManager.generatePlot(plot);
                    p.setFlying(true);
                    Location loc = plot.getSpawn();
                    p.teleport(new Location(Bukkit.getWorld("plots"), loc.getX(), loc.getY(), loc.getZ(), 89.0F, 6.0F));

                }
            }
        }
    }
}