package eu.univento.teamvento.utils;

import eu.univento.core.api.player.CustomPlayer;
import org.bukkit.Bukkit;
import org.bukkit.DyeColor;
import org.bukkit.Material;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.SkullMeta;
import org.bukkit.material.Dye;

public class Inventorys {

    private CustomPlayer player;

    public Inventorys(CustomPlayer player) {
        this.player = player;
    }

    public Inventory getMainInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eGrundstücksverwaltung");

        ItemStack teleport = new ItemStack(Material.MINECART);
        ItemMeta teleportMeta = teleport.getItemMeta();
        teleportMeta.setDisplayName("§eZu anderen Plots teleportieren");
        teleport.setItemMeta(teleportMeta);

        ItemStack biome = new ItemStack(Material.DOUBLE_PLANT, 1, (short) 4);
        ItemMeta biomeMeta = biome.getItemMeta();
        biomeMeta.setDisplayName("§eBiom ändern");
        biome.setItemMeta(biomeMeta);

        ItemStack animals = new ItemStack(Material.LEASH);
        ItemMeta animalsMeta = animals.getItemMeta();
        animalsMeta.setDisplayName("§eTiere");
        animals.setItemMeta(animalsMeta);

        ItemStack settings = new ItemStack(Material.LADDER);
        ItemMeta settingsMeta = settings.getItemMeta();
        settingsMeta.setDisplayName("§eEinstellungen");
        settings.setItemMeta(settingsMeta);

        ItemStack time = new ItemStack(Material.WATCH);
        ItemMeta timeMeta = time.getItemMeta();
        timeMeta.setDisplayName("§eZeit ändern");
        time.setItemMeta(timeMeta);

        ItemStack home = new ItemStack(Material.BED);
        ItemMeta homeMeta = home.getItemMeta();
        homeMeta.setDisplayName("§ezu deinem Plot");
        home.setItemMeta(homeMeta);

        ItemStack weather = new ItemStack(Material.DOUBLE_PLANT);
        ItemMeta weatherMeta = weather.getItemMeta();
        weatherMeta.setDisplayName("§eWetter ändern");
        weather.setItemMeta(weatherMeta);

        Dye resetDye = new Dye();
        resetDye.setColor(DyeColor.RED);
        ItemStack reset = resetDye.toItemStack(1);
        ItemMeta resetMeta = reset.getItemMeta();
        resetMeta.setDisplayName("§ePlot zurücksetzen");
        reset.setItemMeta(resetMeta);

        ItemStack skulls = new ItemStack(Material.SKULL_ITEM, 1, (short) 3);
        SkullMeta skullMeta = (SkullMeta) skulls.getItemMeta();
        skullMeta.setOwner("conorf1807");
        skullMeta.setDisplayName("§eKöpfe");
        skulls.setItemMeta(skullMeta);

        ItemStack particle = new ItemStack(Material.BLAZE_POWDER);
        ItemMeta particleMeta = particle.getItemMeta();
        particleMeta.setDisplayName("§ePartikel");
        particle.setItemMeta(particleMeta);

        Dye readyDye = new Dye();
        readyDye.setColor(DyeColor.LIME);
        ItemStack ready = readyDye.toItemStack(1);
        ItemMeta readyMeta = ready.getItemMeta();
        readyMeta.setDisplayName("§eFertig");
        ready.setItemMeta(readyMeta);

        inv.setItem(0, teleport);
        inv.setItem(2, biome);
        //inv.setItem(6, animals);
        inv.setItem(8, settings);
        inv.setItem(10, time);
        inv.setItem(13, home);
        inv.setItem(16, weather);
        inv.setItem(18, reset);
        inv.setItem(20, skulls);
        //inv.setItem(24, particle);
        inv.setItem(26, ready);

        return inv;
    }

    public Inventory getBiomeInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eBiom ändern");

        ItemStack mesa = new ItemStack(Material.STAINED_CLAY, 1, (short) 1);
        ItemMeta mesaMeta = mesa.getItemMeta();
        mesaMeta.setDisplayName("§eMesa");
        mesa.setItemMeta(mesaMeta);

        ItemStack jungle = new ItemStack(Material.SAPLING, 1, (short) 3);
        ItemMeta jungleMeta = jungle.getItemMeta();
        jungleMeta.setDisplayName("§eDschungel");
        jungle.setItemMeta(jungleMeta);

        ItemStack swamp = new ItemStack(Material.WATER_LILY);
        ItemMeta swampMeta = swamp.getItemMeta();
        swampMeta.setDisplayName("§eSumpfgebiet");
        swamp.setItemMeta(swampMeta);

        ItemStack forest = new ItemStack(Material.SAPLING);
        ItemMeta forestMeta = forest.getItemMeta();
        forestMeta.setDisplayName("§eWald");
        forest.setItemMeta(forestMeta);

        ItemStack flatland = new ItemStack(Material.LONG_GRASS, 1, (short) 1);
        ItemMeta flatlandMeta = flatland.getItemMeta();
        flatlandMeta.setDisplayName("§eFlachland");
        flatland.setItemMeta(flatlandMeta);

        ItemStack desert = new ItemStack(Material.DEAD_BUSH);
        ItemMeta desertMeta = desert.getItemMeta();
        desertMeta.setDisplayName("§eWüste");
        desert.setItemMeta(desertMeta);

        ItemStack taiga = new ItemStack(Material.LONG_GRASS, 1, (short) 2);
        ItemMeta taigaMeta = taiga.getItemMeta();
        taigaMeta.setDisplayName("§eTaiga");
        taiga.setItemMeta(taigaMeta);

        ItemStack tundra = new ItemStack(Material.SNOW_BALL);
        ItemMeta tundraMeta = tundra.getItemMeta();
        tundraMeta.setDisplayName("§eTundra");
        tundra.setItemMeta(tundraMeta);

        inv.setItem(0, mesa);
        inv.setItem(4, jungle);
        inv.setItem(8, swamp);
        inv.setItem(11, forest);
        inv.setItem(15, flatland);
        inv.setItem(18, desert);
        inv.setItem(22, taiga);
        inv.setItem(26, tundra);

        return inv;
    }

    public Inventory getSettingsInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eEinstellungen");

        ItemStack name = new ItemStack(Material.SIGN);
        ItemMeta nameMeta = name.getItemMeta();
        nameMeta.setDisplayName("§eName ändern");
        name.setItemMeta(nameMeta);

        ItemStack contact = new ItemStack(Material.NAME_TAG);
        ItemMeta contactMeta = contact.getItemMeta();
        contactMeta.setDisplayName("§eKontaktmöglichkeiten");
        contact.setItemMeta(contactMeta);

        ItemStack texture = new ItemStack(Material.DIRT);
        ItemMeta textureMeta = texture.getItemMeta();
        textureMeta.setDisplayName("§eResourcePack");
        texture.setItemMeta(textureMeta);

        inv.setItem(10, name);
        inv.setItem(13, contact);
        inv.setItem(16, texture);

        return inv;
    }

    public Inventory getTimeInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eZeit ändern");

        ItemStack morning = new ItemStack(Material.MILK_BUCKET);
        ItemMeta morningMeta = morning.getItemMeta();
        morningMeta.setDisplayName("§eMorgen");
        morning.setItemMeta(morningMeta);

        ItemStack day = new ItemStack(Material.DOUBLE_PLANT);
        ItemMeta dayMeta = day.getItemMeta();
        dayMeta.setDisplayName("§eTag");
        day.setItemMeta(dayMeta);

        ItemStack evening = new ItemStack(Material.BEETROOT_SOUP);
        ItemMeta eveningMeta = evening.getItemMeta();
        eveningMeta.setDisplayName("§eAbend");
        evening.setItemMeta(eveningMeta);

        ItemStack night = new ItemStack(Material.COAL, 1, (short) 1);
        ItemMeta nightMeta = night.getItemMeta();
        nightMeta.setDisplayName("§eNacht");
        night.setItemMeta(nightMeta);

        inv.setItem(10, morning);
        inv.setItem(12, day);
        inv.setItem(14, evening);
        inv.setItem(16, night);

        return inv;
    }

    public Inventory getWeatherInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eWetter ändern");

        ItemStack sun = new ItemStack(Material.DOUBLE_PLANT);
        ItemMeta sunMeta = sun.getItemMeta();
        sunMeta.setDisplayName("§eSonne");
        sun.setItemMeta(sunMeta);

        ItemStack rain = new ItemStack(Material.WATER_BUCKET);
        ItemMeta rainMeta = rain.getItemMeta();
        rainMeta.setDisplayName("§eRegen");
        rain.setItemMeta(rainMeta);

        ItemStack thunder = new ItemStack(Material.BLAZE_ROD);
        ItemMeta thunderMeta = thunder.getItemMeta();
        thunderMeta.setDisplayName("§eGewitter");
        thunder.setItemMeta(thunderMeta);

        inv.setItem(11, sun);
        inv.setItem(13, rain);
        inv.setItem(15, thunder);

        return inv;
    }

    public Inventory getAnimalsInventory() {
        Inventory inv = Bukkit.createInventory(player, 27, "§eTiere spawnen");

        ItemStack pig = new ItemStack(Material.COOKED_BEEF);
        ItemMeta pigMeta = pig.getItemMeta();
        pigMeta.setDisplayName("Schwein gehabt");
        pig.setItemMeta(pigMeta);

        inv.setItem(0, pig);

        return inv;
    }

}